! file gscurrsession_2.gs
!  $Id$
!===================================================================================

! fixed 42355
category: 'Initialization'
method: GsCurrentSession
initialize

| val lib |
" This method is executed once at Session initialization,
  after the ProcessorScheduler is initialized.  It is invoked from
  ProcessorScheduler >> _initialize . 

  To install application specific initialization code, 
  use UserProfile>>loginHook: .

  Deprecated behavior: 
    This method may be modified to invoke application specific 
    initialization code.  

    Use extreme caution when testing modifications to this method.
    Errors in this method may unrecoverably disable commits and
    require restore from backup.  Prior to testing modifications,
    make a full backup of your system.  During testing, disable
    execution of application specific code for user SystemUser to
    allow recovery.
"

val := Globals at: #IcuLibraryVersion otherwise: nil .
(lib := IcuCollator libraryVersion) = val ifFalse:[ 
  ((System myUserProfile userId = 'SystemUser') and:[
    (System gemEnvironmentVariable:'GS_LIB_ICU_BYPASS') notNil]) ifTrue:[
      "ok"
  ] ifFalse:[ | msg |
    msg := 'Globals at: #IcuLibraryVersion = ' , val asString ,
	' ; does not match loaded library = ', lib .
    System disableCommitsWithReason: msg .
    Error signal: msg .
  ].
].

"install a sessionMethodDictionary if GsPackagePolicy is enabled"
GsPackagePolicy enabled
  ifTrue:[ GsPackagePolicy loadSessionMethodDictionary ]
  ifFalse:[ Unicode16 installUnicodeComparePrimitives ].

"invoke the  method or block specified by  UserProfile >> loginHook: "
userProfile _postLoginInitialize .

^ self
%


